# Begin TickleServices Version 1.11 Data
"Divider" = "155.000000";
"Menu Item" = "!Initialization!";
"Tcl" = "\
# Supercite.ts (C) 1995, 1996 Jacob Nielsen <jacob@dannug.dk>
# Testing, suggestions, code improvements , moral support etc:
#                   Peter Rasmussen <rasmus@dannug.dk>

# BTW, external commands are only called in the proc 'fmt'
# (the command 'fmt' is called) You might want to call the
# GNU fmt instead of NeXT's fmt. The GNU fmt is 8bit clean :-)
#

# This version of exec doesn't strip the trailing newline from the
# output.

proc nexec {args} {
    set fileId [uplevel open [list [format \"|%s\" $args]]]
    set ret [read $fileId]
    close $fileId
    return $ret
}

# The string used to quote text.
global quoteString
set quoteString \"foobar\"

# Reformat the passed string.
# Note that this 'fmt' takes the length of a citation string into acc\
ount.

proc fmt {str {cite_length 0} {goal_length 65} {max_length 75}} {
  set fmtWidth [expr $goal_length-$cite_length]
   return [nexec /usr/ucb/fmt $fmtWidth $max_length << $str]
}

# I suggest using this 'proc fmt' when using the GNU fmt:
# And no, setting goal_length to 70 is *not* a mistake.
# GNU fmt tries to make the line length 7% shorter than the
# user supplied width (-w).

#proc fmt {str {cite_length 0} {goal_length 70} {max_length 75}} {
#  set fmtWidth [expr $goal_length-$cite_length]
#   return [nexec /coll/local/bin/fmt -w $fmtWidth -u  << $str]
#}

proc quote {str {qs {}}} {
    if {![string length $qs]} {
        global quoteString
        set qs $quoteString
				append qs \"> \"
    }
    if {[regsub -all \"^(\\[^\\n\\]*)(\\n?)\" $str \"[escape $qs {\\\\\
&}]\\\\1\\\\2\" foo]} {
	return $foo
    } else {
	return $str
    }
}

# Removing quotes...
#
# First I try to match and remove the ugly citation characters, I nor\
mally see.
# If thats unsuccesfull, I try to match and remove a Supercite style \
citation.
# Nested 'ugly' and Supercite style quotations must be removed by app\
lying
# this proc several times.

proc unquote {str} {
    if {[regsub -all \"(^\\[\\]\\[:\\{\\}>\\]+\\[ \\]?)(\\[^\\n\\]*)(\
\\n?)\" $str \"\\\\2\\\\3\" foo]} {
	return $foo
    } else {
        if {[regsub -all -nocase \"(^\\[^>\\]+>\\[ \\]?)(\\[^\\n\\]*)\
(\\n?)\" $str \"\\\\2\\\\3\" foo]} {
			  return $foo
			} 
	return $str
    }
}
# BTW, here's the def. from gnus-cite.el in Gnus5...
#(defvar gnus-cite-prefix-regexp 
#   \"^[]>|:}+ ]*[]>|:}+]\\\\(.*>\\\\)?\\\\|^.*>\"
# \"Regexp matching the longest possible citation prefix on a line.\"\
)


# Guessing the citation name from a line with the email address or 
# from a text block with a 'From: ' line.
#
# The recognized forms:
# 1. Jacob Nielsen <jacob@dannug.dk>
# 1a. Jacob Nielsen <jacob>
# 2. jacob@dannug.dk (Jacob Nielsen)
# 2a. jacob (Jacob Nielsen)

proc guessQuoteString {str1} {
# Record only the 'From: ' line ('From: ' is removed)
# If the 'From: ' line can't be found, we use the first line instead!

 set str \"\"
 if {![regexp \"(From: )(\\[^\\n\\]*)\" $str1 discard discard str]} {
   set discard [regexp \"(\\[^\\n\\]*)\" $str1 discard str]
}
# Using '^' in this context means matching the null string at the
# beginning of the *string* not at the beginning of each line >:-(

# Clear the selected area...
  pasteboard write $str

# Case No 1
     if {[regexp \"<\\[^ \\]+>\" $str email] } {
          if {[regexp \"(\\[^ \\]+)\" $str discard firstName] } {
				   return $firstName
				 } else {
				   return $email
				 }
# Case No 2		
			} elseif {[regexp \"(\\[^ \\]+)\" $str email] } {
			  if {[regexp \"(\\()(\\[^ \\]+)\" $str discard discard firstName]\
} {
# A firstname was found...
					return $firstName
				} else {
# email was found in the 'elseif' above !
				  return $email
				}					
			}
# This shouldn't happen at all...
			return \"foobar\"
}";
"Window Size" = "{ 855.000, 660.000}";
|
"Menu Item" = "Supercite/Cite...";
"Receive Type" = "NXAsciiPboardType";
"Send Type" = "NXAsciiPboardType";
"Tcl" = "\
# Reformat and cite the given text.

if {![catch {promptpanel -message {Enter citation name} Cite $quoteSt\
ring} qs]} {
  global quoteString
  set quoteString $qs

  set qs $quoteString 
  append qs \"> \"
	
# The proc 'fmt' takes the length of the citation string as the secon\
d argument.
set qsWidth [string length $qs]
pasteboard write [quote [fmt [pasteboard read] $qsWidth] $qs]
}";
|
"Menu Item" = "Supercite/Insert Name...";
"Receive Type" = "NXAsciiPboardType";
"Send Type" = "NXAsciiPboardType";
"Tcl" = "\
set tmpSel [pasteboard read]
set qs [guessQuoteString $tmpSel]

if {![catch {promptpanel -message {Enter citation name} Cite $qs} qs]\
} {
  global quoteString
  set quoteString $qs
  set tmp \">>>>> \\\"\"
  append tmp $quoteString
  append tmp \"\\\" == \"
  append tmp [pasteboard read]
  append tmp \" writes:\\n\"
  pasteboard write $tmp
} else {
  pasteboard write $tmpSel
}";
|
"Menu Item" = "Supercite/Reformat Lines";
"Receive Type" = "NXAsciiPboardType";
"Send Type" = "NXAsciiPboardType";
"Tcl" = "\
# Reformat the given text.

pasteboard write [fmt [pasteboard read]]
";
|
"Menu Item" = "Supercite/Unquote";
"Receive Type" = "NXAsciiPboardType";
"Send Type" = "NXAsciiPboardType";
"Tcl" = "\
# Unquote the given text.
# Note: This removes all of the ugly quote strings I've seen people u\
se :-)
# and it also removes quote strings a la Supercite :-(

pasteboard write [unquote [pasteboard read]]
";
|
"Menu Item" = "Supercite/Unquote and Cite...";
"Receive Type" = "NXAsciiPboardType";
"Send Type" = "NXAsciiPboardType";
"Tcl" = "\
# Unquote, reformat and cite the given text.
# Note: If used on something containing a '>', everything up to and i\
ncluding
# the '>' will disappear... (since 'unquote' thinks everything before\
 a '>' is a quotation
# string) This produces undesirable effects if used on text that's no\
t quoted ! 
# Use at your own risk :-)

if {![catch {promptpanel -message {Enter citation name} Cite $quoteSt\
ring} qs]} {
  global quoteString
  set quoteString $qs

  set qs $quoteString 
  append qs \"> \"
	
# The proc 'fmt' takes the length of the citation string as the secon\
d argument.
  set qsWidth [string length $qs]
  pasteboard write [quote [fmt [unquote [pasteboard read]] $qsWidth] \
$qs]
}";
# End TickleServices Data
